Index: contrib/Pallet/Growl-1.2.1-Framework/Growl.framework/Versions/A/Headers/GrowlDefines.h
===================================================================
--- contrib/Pallet/Growl-1.2.1-Framework/Growl.framework/Versions/A/Headers/GrowlDefines.h	(revision 72223)
+++ contrib/Pallet/Growl-1.2.1-Framework/Growl.framework/Versions/A/Headers/GrowlDefines.h	(revision 72223)
@@ -0,0 +1,348 @@
+//
+//  GrowlDefines.h
+//
+
+#ifndef _GROWLDEFINES_H
+#define _GROWLDEFINES_H
+
+#ifdef __OBJC__
+#define XSTR(x) (@x)
+#define STRING_TYPE NSString *
+#else
+#define XSTR CFSTR
+#define STRING_TYPE CFStringRef
+#endif
+
+/*!	@header GrowlDefines.h
+ *	@abstract   Defines all the notification keys.
+ *	@discussion Defines all the keys used for registration with Growl and for
+ *	 Growl notifications.
+ *
+ *	 Most applications should use the functions or methods of Growl.framework
+ *	 instead of posting notifications such as those described here.
+ *	@updated 2004-01-25
+ */
+
+// UserInfo Keys for Registration
+#pragma mark UserInfo Keys for Registration
+
+/*!	@group Registration userInfo keys */
+/*	@abstract	Keys for the userInfo dictionary of a GROWL_APP_REGISTRATION distributed notification.
+ *	@discussion The values of these keys describe the application and the
+ *	 notifications it may post.
+ *
+ *	 Your application must register with Growl before it can post Growl
+ *	 notifications (and have them not be ignored). However, as of Growl 0.6,
+ *	 posting GROWL_APP_REGISTRATION notifications directly is no longer the
+ *	 preferred way to register your application. Your application should instead
+ *	 use Growl.framework's delegate system.
+ *	 See +[GrowlApplicationBridge setGrowlDelegate:] or Growl_SetDelegate for
+ *	 more information.
+ */
+
+/*!	@defined GROWL_APP_NAME
+ *	@abstract The name of your application.
+ *	@discussion The name of your application. This should remain stable between
+ *	 different versions and incarnations of your application.
+ *	 For example, "SurfWriter" is a good app name, whereas "SurfWriter 2.0" and
+ *	 "SurfWriter Lite" are not.
+ */
+#define GROWL_APP_NAME					XSTR("ApplicationName")
+/*!	@defined GROWL_APP_ID
+ *	@abstract The bundle identifier of your application.
+ *	@discussion The bundle identifier of your application. This key should
+ *   be unique for your application while there may be several applications
+ *   with the same GROWL_APP_NAME.
+ *   This key is optional.
+ */
+#define GROWL_APP_ID					XSTR("ApplicationId")
+/*!	@defined GROWL_APP_ICON
+ *	@abstract The image data for your application's icon.
+ *	@discussion Image data representing your application's icon. This may be
+ *	 superimposed on a notification icon as a badge, used as the notification
+ *	 icon when a notification-specific icon is not supplied, or ignored
+ *	 altogether, depending on the display. Must be in a format supported by
+ *	 NSImage, such as TIFF, PNG, GIF, JPEG, BMP, PICT, or PDF.
+ *
+ *	 Optional. Not supported by all display plugins.
+ */
+#define GROWL_APP_ICON					XSTR("ApplicationIcon")
+/*!	@defined GROWL_NOTIFICATIONS_DEFAULT
+ *	@abstract The array of notifications to turn on by default.
+ *	@discussion These are the names of the notifications that should be enabled
+ *	 by default when your application registers for the first time. If your
+ *	 application reregisters, Growl will look here for any new notification
+ *	 names found in GROWL_NOTIFICATIONS_ALL, but ignore any others.
+ */
+#define GROWL_NOTIFICATIONS_DEFAULT		XSTR("DefaultNotifications")
+/*!	@defined GROWL_NOTIFICATIONS_ALL
+ *	@abstract The array of all notifications your application can send.
+ *	@discussion These are the names of all of the notifications that your
+ *	 application may post. See GROWL_NOTIFICATION_NAME for a discussion of good
+ *	 notification names.
+ */
+#define GROWL_NOTIFICATIONS_ALL			XSTR("AllNotifications")
+/*! @defined GROWL_NOTIFICATIONS_HUMAN_READABLE_DESCRIPTIONS
+ *  @abstract A dictionary of human-readable names for your notifications.
+ *  @discussion By default, the Growl UI will display notifications by the names given in GROWL_NOTIFICATIONS_ALL
+ *  which correspond to the GROWL_NOTIFICATION_NAME. This dictionary specifies the human-readable name to display.
+ *  The keys of the dictionary are GROWL_NOTIFICATION_NAME strings; the objects are the human-readable versions.
+ *  For any GROWL_NOTIFICATION_NAME not specific in this dictionary, the GROWL_NOTIFICATION_NAME will be displayed.
+ *
+ *  This key is optional.
+ */
+#define GROWL_NOTIFICATIONS_HUMAN_READABLE_NAMES		XSTR("HumanReadableNames")
+/*! @defined GROWL_NOTIFICATIONS_DESCRIPTIONS
+*  @abstract A dictionary of descriptions of _when_ each notification occurs
+*  @discussion This is an NSDictionary whose keys are GROWL_NOTIFICATION_NAME strings and whose objects are
+*  descriptions of _when_ each notification occurs, such as "You received a new mail message" or
+*  "A file finished downloading".
+*
+*  This key is optional.
+*/
+#define GROWL_NOTIFICATIONS_DESCRIPTIONS		XSTR("NotificationDescriptions")
+
+/*!	@defined	GROWL_TICKET_VERSION
+ *	@abstract	The version of your registration ticket.
+ *	@discussion	Include this key in a ticket plist file that you put in your
+ *	 application bundle for auto-discovery. The current ticket version is 1.
+ */
+#define GROWL_TICKET_VERSION			XSTR("TicketVersion")
+// UserInfo Keys for Notifications
+#pragma mark UserInfo Keys for Notifications
+
+/*!	@group Notification userInfo keys */
+/*	@abstract	Keys for the userInfo dictionary of a GROWL_NOTIFICATION distributed notification.
+ *	@discussion The values of these keys describe the content of a Growl
+ *	 notification.
+ *
+ *	 Not all of these keys are supported by all displays. Only the name, title,
+ *	 and description of a notification are universal. Most of the built-in
+ *	 displays do support all of these keys, and most other visual displays
+ *	 probably will also. But, as of 0.6, the Log, MailMe, and Speech displays
+ *	 support only textual data.
+ */
+
+/*!	@defined GROWL_NOTIFICATION_NAME
+ *	@abstract The name of the notification.
+ *	@discussion The name of the notification. Note that if you do not define
+ *  GROWL_NOTIFICATIONS_HUMAN_READABLE_NAMES when registering your ticket originally this name
+ *  will the one displayed within the Growl preference pane and should be human-readable.
+ */
+#define GROWL_NOTIFICATION_NAME			XSTR("NotificationName")
+/*!	@defined GROWL_NOTIFICATION_TITLE
+ *	@abstract The title to display in the notification.
+ *	@discussion The title of the notification. Should be very brief.
+ *	 The title usually says what happened, e.g. "Download complete".
+ */
+#define GROWL_NOTIFICATION_TITLE		XSTR("NotificationTitle")
+/*!	@defined GROWL_NOTIFICATION_DESCRIPTION
+ *	@abstract The description to display in the notification.
+ *	@discussion The description should be longer and more verbose than the title.
+ *	 The description usually tells the subject of the action,
+ *	 e.g. "Growl-0.6.dmg downloaded in 5.02 minutes".
+ */
+#define GROWL_NOTIFICATION_DESCRIPTION  	XSTR("NotificationDescription")
+/*!	@defined GROWL_NOTIFICATION_ICON
+ *	@discussion Image data for the notification icon. Must be in a format
+ *	 supported by NSImage, such as TIFF, PNG, GIF, JPEG, BMP, PICT, or PDF.
+ *
+ *	 Optional. Not supported by all display plugins.
+ */
+#define GROWL_NOTIFICATION_ICON			XSTR("NotificationIcon")
+/*!	@defined GROWL_NOTIFICATION_APP_ICON
+ *	@discussion Image data for the application icon, in case GROWL_APP_ICON does
+ *	 not apply for some reason. Must be in a format supported by NSImage, such
+ *	 as TIFF, PNG, GIF, JPEG, BMP, PICT, or PDF.
+ *
+ *	 Optional. Not supported by all display plugins.
+ */
+#define GROWL_NOTIFICATION_APP_ICON		XSTR("NotificationAppIcon")
+/*!	@defined GROWL_NOTIFICATION_PRIORITY
+ *	@discussion The priority of the notification as an integer number from
+ *	 -2 to +2 (+2 being highest).
+ *
+ *	 Optional. Not supported by all display plugins.
+ */
+#define GROWL_NOTIFICATION_PRIORITY		XSTR("NotificationPriority")
+/*!	@defined GROWL_NOTIFICATION_STICKY
+ *	@discussion A Boolean number controlling whether the notification is sticky.
+ *
+ *	 Optional. Not supported by all display plugins.
+ */
+#define GROWL_NOTIFICATION_STICKY		XSTR("NotificationSticky")
+/*!	@defined GROWL_NOTIFICATION_CLICK_CONTEXT
+ *	@abstract Identifies which notification was clicked.
+ *	@discussion An identifier for the notification for clicking purposes.
+ *
+ *	 This will be passed back to the application when the notification is
+ *	 clicked. It must be plist-encodable (a data, dictionary, array, number, or
+ *	 string object), and it should be unique for each notification you post.
+ *	 A good click context would be a UUID string returned by NSProcessInfo or
+ *	 CFUUID.
+ *
+ *	 Optional. Not supported by all display plugins.
+ */
+#define GROWL_NOTIFICATION_CLICK_CONTEXT			XSTR("NotificationClickContext")
+
+/*!	@defined GROWL_DISPLAY_PLUGIN
+ *	@discussion The name of a display plugin which should be used for this notification.
+ *    Optional. If this key is not set or the specified display plugin does not
+ *    exist, the display plugin stored in the application ticket is used. This key
+ *    allows applications to use different default display plugins for their
+ *    notifications. The user can still override those settings in the preference
+ *    pane.
+ */
+#define GROWL_DISPLAY_PLUGIN				XSTR("NotificationDisplayPlugin")
+
+/*!	@defined GROWL_NOTIFICATION_IDENTIFIER
+ *	@abstract An identifier for the notification for coalescing purposes.
+ *   Notifications with the same identifier fall into the same class; only
+ *   the last notification of a class is displayed on the screen. If a
+ *   notification of the same class is currently being displayed, it is
+ *   replaced by this notification.
+ *
+ *	 Optional. Not supported by all display plugins.
+ */
+#define GROWL_NOTIFICATION_IDENTIFIER	XSTR("GrowlNotificationIdentifier")
+
+/*!	@defined GROWL_APP_PID
+ *	@abstract The process identifier of the process which sends this
+ *   notification. If this field is set, the application will only receive
+ *   clicked and timed out notifications which originate from this process.
+ *
+ *	 Optional.
+ */
+#define GROWL_APP_PID					XSTR("ApplicationPID")
+
+/*!	@defined GROWL_NOTIFICATION_PROGRESS
+*	@abstract If this key is set, it should contain a double value wrapped
+*     in a NSNumber which describes some sort of progress (from 0.0 to 100.0).
+*     If this is key is not set, no progress bar is shown.
+*
+*	 Optional. Not supported by all display plugins.
+*/
+#define GROWL_NOTIFICATION_PROGRESS		XSTR("NotificationProgress")
+
+// Notifications
+#pragma mark Notifications
+
+/*!	@group Notification names */
+/*	@abstract	Names of distributed notifications used by Growl.
+ *	@discussion	These are notifications used by applications (directly or
+ *	 indirectly) to interact with Growl, and by Growl for interaction between
+ *	 its components.
+ *
+ *	 Most of these should no longer be used in Growl 0.6 and later, in favor of
+ *	 Growl.framework's GrowlApplicationBridge APIs.
+ */
+
+/*!	@defined GROWL_APP_REGISTRATION
+ *	@abstract The distributed notification for registering your application.
+ *	@discussion This is the name of the distributed notification that can be
+ *	 used to register applications with Growl.
+ *
+ *	 The userInfo dictionary for this notification can contain these keys:
+ *	 <ul>
+ *	 	<li>GROWL_APP_NAME</li>
+ *	 	<li>GROWL_APP_ICON</li>
+ *	 	<li>GROWL_NOTIFICATIONS_ALL</li>
+ *	 	<li>GROWL_NOTIFICATIONS_DEFAULT</li>
+ *	 </ul>
+ *
+ *	 No longer recommended as of Growl 0.6. An alternate method of registering
+ *	 is to use Growl.framework's delegate system.
+ *	 See +[GrowlApplicationBridge setGrowlDelegate:] or Growl_SetDelegate for
+ *	 more information.
+ */
+#define GROWL_APP_REGISTRATION			XSTR("GrowlApplicationRegistrationNotification")
+/*!	@defined GROWL_APP_REGISTRATION_CONF
+ *	@abstract The distributed notification for confirming registration.
+ *	@discussion The name of the distributed notification sent to confirm the
+ *	 registration. Used by the Growl preference pane. Your application probably
+ *	 does not need to use this notification.
+ */
+#define GROWL_APP_REGISTRATION_CONF		XSTR("GrowlApplicationRegistrationConfirmationNotification")
+/*!	@defined GROWL_NOTIFICATION
+ *	@abstract The distributed notification for Growl notifications.
+ *	@discussion This is what it all comes down to. This is the name of the
+ *	 distributed notification that your application posts to actually send a
+ *	 Growl notification.
+ *
+ *	 The userInfo dictionary for this notification can contain these keys:
+ *	 <ul>
+ *	 	<li>GROWL_NOTIFICATION_NAME (required)</li>
+ *	 	<li>GROWL_NOTIFICATION_TITLE (required)</li>
+ *	 	<li>GROWL_NOTIFICATION_DESCRIPTION (required)</li>
+ *	 	<li>GROWL_NOTIFICATION_ICON</li>
+ *	 	<li>GROWL_NOTIFICATION_APP_ICON</li>
+ *	 	<li>GROWL_NOTIFICATION_PRIORITY</li>
+ *	 	<li>GROWL_NOTIFICATION_STICKY</li>
+ *	 	<li>GROWL_NOTIFICATION_CLICK_CONTEXT</li>
+ *	 	<li>GROWL_APP_NAME (required)</li>
+ *	 </ul>
+ *
+ *	 No longer recommended as of Growl 0.6. Three alternate methods of posting
+ *	 notifications are +[GrowlApplicationBridge notifyWithTitle:description:notificationName:iconData:priority:isSticky:clickContext:],
+ *	 Growl_NotifyWithTitleDescriptionNameIconPriorityStickyClickContext, and
+ *	 Growl_PostNotification.
+ */
+#define GROWL_NOTIFICATION				XSTR("GrowlNotification")
+/*!	@defined GROWL_SHUTDOWN
+*	@abstract The distributed notification name that tells Growl to shutdown.
+*	@discussion The Growl preference pane posts this notification when the
+*	 "Stop Growl" button is clicked.
+*/
+#define GROWL_SHUTDOWN					XSTR("GrowlShutdown")
+/*!	@defined GROWL_PING
+ *	@abstract A distributed notification to check whether Growl is running.
+ *	@discussion This is used by the Growl preference pane. If it receives a
+ *	 GROWL_PONG, the preference pane takes this to mean that Growl is running.
+ */
+#define GROWL_PING						XSTR("Honey, Mind Taking Out The Trash")
+/*!	@defined GROWL_PONG
+ *	@abstract The distributed notification sent in reply to GROWL_PING.
+ *	@discussion GrowlHelperApp posts this in reply to GROWL_PING.
+ */
+#define GROWL_PONG						XSTR("What Do You Want From Me, Woman")
+/*!	@defined GROWL_IS_READY
+ *	@abstract The distributed notification sent when Growl starts up.
+ *	@discussion GrowlHelperApp posts this when it has begin listening on all of
+ *	 its sources for new notifications. GrowlApplicationBridge (in
+ *	 Growl.framework), upon receiving this notification, reregisters using the
+ *	 registration dictionary supplied by its delegate.
+ */
+#define GROWL_IS_READY					XSTR("Lend Me Some Sugar; I Am Your Neighbor!")
+/*!	@defined GROWL_NOTIFICATION_CLICKED
+ *	@abstract The distributed notification sent when a supported notification is clicked.
+ *	@discussion When a Growl notification with a click context is clicked on by
+ *	 the user, Growl posts this distributed notification.
+ *	 The GrowlApplicationBridge responds to this notification by calling a
+ *	 callback in its delegate.
+ */
+#define GROWL_NOTIFICATION_CLICKED		XSTR("GrowlClicked!")
+#define GROWL_NOTIFICATION_TIMED_OUT	XSTR("GrowlTimedOut!")
+
+/*!	@group Other symbols */
+/* Symbols which don't fit into any of the other categories. */
+
+/*!	@defined GROWL_KEY_CLICKED_CONTEXT
+ *	@abstract Used internally as the key for the clickedContext passed over DNC.
+ *	@discussion This key is used in GROWL_NOTIFICATION_CLICKED, and contains the
+ *	 click context that was supplied in the original notification.
+ */
+#define GROWL_KEY_CLICKED_CONTEXT		XSTR("ClickedContext")
+/*!	@defined GROWL_REG_DICT_EXTENSION
+ *	@abstract The filename extension for registration dictionaries.
+ *	@discussion The GrowlApplicationBridge in Growl.framework registers with
+ *	 Growl by creating a file with the extension of .(GROWL_REG_DICT_EXTENSION)
+ *	 and opening it in the GrowlHelperApp. This happens whether or not Growl is
+ *	 running; if it was stopped, it quits immediately without listening for
+ *	 notifications.
+ */
+#define GROWL_REG_DICT_EXTENSION		XSTR("growlRegDict")
+
+
+#define GROWL_POSITION_PREFERENCE_KEY			@"GrowlSelectedPosition"
+
+#endif //ndef _GROWLDEFINES_H
Index: contrib/Pallet/Growl-1.2.1-Framework/Growl.framework/Versions/Current
===================================================================
--- contrib/Pallet/Growl-1.2.1-Framework/Growl.framework/Versions/Current	(revision 72223)
+++ contrib/Pallet/Growl-1.2.1-Framework/Growl.framework/Versions/Current	(revision 72223)
@@ -0,0 +1,1 @@
+link A
Index: contrib/Pallet/GrowlNotifications.h
===================================================================
--- contrib/Pallet/GrowlNotifications.h	(revision 72223)
+++ contrib/Pallet/GrowlNotifications.h	(revision 72223)
@@ -0,0 +1,26 @@
+/*
+ *  GrowlNotifications.h
+ *  Pallet
+ *
+ *  Created by Vasileios Georgitzikis on 19/6/10.
+ *  Copyright 2010 Tzikis. All rights reserved.
+ *
+ */
+
+/* Defining growl types*/
+
+/**/
+#define GROWL_TYPES 12
+#define GROWL_INSTALL 0
+#define GROWL_UNINSTALL 1
+#define GROWL_UPGRADE 2
+#define GROWL_SYNC 3
+#define GROWL_SELFUPDATE 4
+#define GROWL_INSTALLFAILED 5
+#define GROWL_UNINSTALLFAILED 6
+#define GROWL_UPGRADEFAILED 7
+#define GROWL_SYNCFAILED 8
+#define GROWL_SELFUPDATEFAILED 9
+
+#define GROWL_ALLOPS 10
+#define GROWL_ALLOPSFAILED 11
Index: contrib/Pallet/MPActionLauncher.h
===================================================================
--- contrib/Pallet/MPActionLauncher.h	(revision 65496)
+++ contrib/Pallet/MPActionLauncher.h	(revision 72223)
@@ -16,4 +16,7 @@
 #import <Cocoa/Cocoa.h>
 #import <MacPorts/MacPorts.h>
+#import <Growl/Growl.h>
+
+#import "GrowlNotifications.h"
 
 /*!
@@ -22,5 +25,5 @@
  @discussion Contains a shared per thread MacPorts Framework wrapper
 */
-@interface MPActionLauncher : NSObject {
+@interface MPActionLauncher : NSObject <GrowlApplicationBridgeDelegate> {
     NSArray *ports;
     NSTask *actionTool;
@@ -59,4 +62,11 @@
 
 /*!
+ @brief Installs a single port with the selected variants in another thread
+ @param portAndVariands NSArray which includes the port to install and its variants
+ */
+
+- (void)installPortWithVariants:(NSArray *)portAndVariants;
+
+/*!
  @brief Uninstalls a single port in another thread
  @param port MPPort that represents the port to install
@@ -83,3 +93,5 @@
 - (void)cancelPortProcess;
 
+-(void) sendGrowlNotification: (int) type;
+
 @end
Index: contrib/Pallet/MPActionLauncher.m
===================================================================
--- contrib/Pallet/MPActionLauncher.m	(revision 65496)
+++ contrib/Pallet/MPActionLauncher.m	(revision 72223)
@@ -8,4 +8,6 @@
 
 #import "MPActionLauncher.h"
+
+extern BOOL errorReceived;
 
 static MPActionLauncher *sharedActionLauncher = nil;
@@ -49,27 +51,99 @@
 
 - (void)installPort:(MPPort *)port {
+	errorReceived=NO;
     NSError * error;
     NSArray *empty = [NSArray arrayWithObject: @""];
     [port installWithOptions:empty variants:empty error:&error];
+	//Check if we have received an error, send the apropriate notification, and if everything is fine
+	//send a notification to the main thread that we have completed our operation, and to advance the queue
+	if(errorReceived)
+		[self sendGrowlNotification: GROWL_INSTALLFAILED];
+	else
+	{
+		[self sendGrowlNotification: GROWL_INSTALL];
+		[[NSNotificationCenter defaultCenter] postNotificationName:@"advanceQ" object:nil userInfo:nil];
+	}
+	
+}
+
+- (void)installPortWithVariants:(NSArray *) portAndVariants {
+	errorReceived=NO;
+    NSError * error;
+    NSArray *empty = [NSArray arrayWithObject: @""];
+	//Because we get the port and the variants mixed in an array, we copy the port to a local variable,
+	//and the variants array to a local array
+	MPPort* port = [portAndVariants objectAtIndex:0];
+	NSArray *variants = [portAndVariants objectAtIndex:1];
+    [port installWithOptions:empty variants:variants error:&error];
+	//Check if we have received an error, send the apropriate notification, and if everything is fine
+	//send a notification to the main thread that we have completed our operation, and to advance the queue
+	if(errorReceived)
+		[self sendGrowlNotification: GROWL_INSTALLFAILED];
+	else
+	{
+		[self sendGrowlNotification: GROWL_INSTALL];
+		[[NSNotificationCenter defaultCenter] postNotificationName:@"advanceQ" object:nil userInfo:nil];
+	}
+	
 }
 
 - (void)uninstallPort:(MPPort *)port {
+	errorReceived=NO;
     NSError * error;
     [port uninstallWithVersion:@"" error:&error];
+	//Check if we have received an error, send the apropriate notification, and if everything is fine
+	//send a notification to the main thread that we have completed our operation, and to advance the queue
+	if(errorReceived)
+		[self sendGrowlNotification: GROWL_UNINSTALLFAILED];
+	else
+	{
+		[self sendGrowlNotification: GROWL_UNINSTALL];
+		[[NSNotificationCenter defaultCenter] postNotificationName:@"advanceQ" object:nil userInfo:nil];
+	}
 }
 
 - (void)upgradePort:(MPPort *)port {
+	errorReceived=NO;
     NSError * error;
     [port upgradeWithError:&error];
+	//Check if we have received an error, send the apropriate notification, and if everything is fine
+	//send a notification to the main thread that we have completed our operation, and to advance the queue
+	if(errorReceived)
+		[self sendGrowlNotification: GROWL_UPGRADEFAILED];
+	else
+	{
+		[self sendGrowlNotification: GROWL_UPGRADE];
+		[[NSNotificationCenter defaultCenter] postNotificationName:@"advanceQ" object:nil userInfo:nil];
+	}
 }
 
 - (void)sync {
+	errorReceived=NO;
     NSError * error;
     [[MPMacPorts sharedInstance] sync:&error];
+	//Check if we have received an error, send the apropriate notification, and if everything is fine
+	//send a notification to the main thread that we have completed our operation, and to advance the queue
+	if(errorReceived)
+		[self sendGrowlNotification: GROWL_SYNCFAILED];
+	else
+	{
+		[self sendGrowlNotification: GROWL_SYNC];
+		[[NSNotificationCenter defaultCenter] postNotificationName:@"advanceQ" object:nil userInfo:nil];
+	}
 }
 
 - (void)selfupdate {
+	errorReceived=NO;
     NSError * error;
     [[MPMacPorts sharedInstance] selfUpdate:&error];
+	//Check if we have received an error, send the apropriate notification, and if everything is fine
+	//send a notification to the main thread that we have completed our operation, and to advance the queue
+	if(errorReceived)
+		[self sendGrowlNotification: GROWL_SELFUPDATEFAILED];
+	else
+	{
+		[self sendGrowlNotification: GROWL_SELFUPDATE];
+		[[NSNotificationCenter defaultCenter] postNotificationName:@"advanceQ" object:nil userInfo:nil];
+	}
 }
 
@@ -79,3 +153,68 @@
 }
 
+//sendGrowlNotification is the method used to send our Growl notifications, via the Growl framework. It takes one argument, which is the
+//type of notification we are sending, as defined in GrowlNotifications.h It initializes the strings we will be sending to the
+//Growl Framework that comprise our notification, and finaly sends the notification
+-(void) sendGrowlNotification:(int)type
+{
+	//The notification needs a title. We initialize an array containing the titles for each type of notification
+	NSString *growlTitles[GROWL_TYPES];
+	growlTitles[GROWL_INSTALL] = [NSString stringWithString: @"Installation Completed"];
+	growlTitles[GROWL_UNINSTALL] = [NSString stringWithString: @"Uninstall Completed"];
+	growlTitles[GROWL_UPGRADE] = [NSString stringWithString: @"Upgrade Completed"];
+	growlTitles[GROWL_SYNC] = [NSString stringWithString: @"Sync Completed"];
+	growlTitles[GROWL_SELFUPDATE] = [NSString stringWithString: @"Selfupdate Completed"];
+	growlTitles[GROWL_INSTALLFAILED] = [NSString stringWithString: @"Installation Failed"];
+	growlTitles[GROWL_UNINSTALLFAILED] = [NSString stringWithString: @"Uninstall Failed"];
+	growlTitles[GROWL_UPGRADEFAILED] = [NSString stringWithString: @"Upgrade Failed"];
+	growlTitles[GROWL_SYNCFAILED] = [NSString stringWithString: @"Sync Failed"];
+	growlTitles[GROWL_SELFUPDATEFAILED] = [NSString stringWithString: @"Selfupdate Failed"];
+
+	growlTitles[GROWL_ALLOPS] = [NSString stringWithString: @"Operations Completed"];
+	growlTitles[GROWL_ALLOPSFAILED] = [NSString stringWithString: @"Operations Failed"];
+
+	//The notification also needs a description. We initialize an array containing the descriptions for each type of notification
+	NSString *growlDescriptions[GROWL_TYPES];	
+	growlDescriptions[GROWL_INSTALL] = [NSString stringWithString: @"Operation completed successfully"];
+	growlDescriptions[GROWL_UNINSTALL] = [NSString stringWithString: @"Operation completed successfully"];
+	growlDescriptions[GROWL_UPGRADE] = [NSString stringWithString: @"Operation completed successfully"];
+	growlDescriptions[GROWL_SYNC] = [NSString stringWithString: @"Operation completed successfully"];
+	growlDescriptions[GROWL_SELFUPDATE] = [NSString stringWithString: @"Operation completed successfully"];
+	growlDescriptions[GROWL_INSTALLFAILED] = [NSString stringWithString: @"Operation Failed"];
+	growlDescriptions[GROWL_UNINSTALLFAILED] = [NSString stringWithString: @"Operation Failed"];
+	growlDescriptions[GROWL_UPGRADEFAILED] = [NSString stringWithString: @"Operation Failed"];
+	growlDescriptions[GROWL_SYNCFAILED] = [NSString stringWithString: @"Operation Failed"];
+	growlDescriptions[GROWL_SELFUPDATEFAILED] = [NSString stringWithString: @"Operation Failed"];
+
+	growlDescriptions[GROWL_ALLOPS] = [NSString stringWithString: @"All Operations Completed Succesfully"];
+	growlDescriptions[GROWL_ALLOPSFAILED] = [NSString stringWithString: @"Operations Failed"];
+
+	//And the notification also needs a name, which Growl uses to identify it. We initialize an array containing
+	//these names here
+	NSString *growlNotificationNames[GROWL_TYPES];
+	growlNotificationNames[GROWL_INSTALL] = [NSString stringWithString: @"InstallCompleted"];
+	growlNotificationNames[GROWL_UNINSTALL] = [NSString stringWithString: @"UninstallCompleted"];
+	growlNotificationNames[GROWL_UPGRADE] = [NSString stringWithString: @"UpgradeCompleted"];
+	growlNotificationNames[GROWL_SYNC] = [NSString stringWithString: @"SyncCompleted"];
+	growlNotificationNames[GROWL_SELFUPDATE] = [NSString stringWithString: @"SelfupdateCompleted"];
+	growlNotificationNames[GROWL_INSTALLFAILED] = [NSString stringWithString: @"InstallFailed"];
+	growlNotificationNames[GROWL_UNINSTALLFAILED] = [NSString stringWithString: @"UninstallFailed"];
+	growlNotificationNames[GROWL_UPGRADEFAILED] = [NSString stringWithString: @"UpgradeFailed"];
+	growlNotificationNames[GROWL_SYNCFAILED] = [NSString stringWithString: @"SyncFailed"];
+	growlNotificationNames[GROWL_SELFUPDATEFAILED] = [NSString stringWithString: @"SelfupdateFailed"];
+	
+	growlNotificationNames[GROWL_ALLOPS] = [NSString stringWithString: @"OperationsCompleted"];
+	growlNotificationNames[GROWL_ALLOPSFAILED] = [NSString stringWithString: @"OperationsFailed"];
+	
+	
+	/*#################	These initializations should be moved to [init], and only call the following functions 	#################*/
+	
+	//Before we can send our messages, we need to call setGrowlDelegate once, due to a bug with the Growl Framework
+	[GrowlApplicationBridge setGrowlDelegate:(id) @""];
+	//And finaly, we send our notification, by calling notifyWithTitle with the appropriate title/description/name 
+	[GrowlApplicationBridge notifyWithTitle: growlTitles[type] description: growlDescriptions[type]\
+						   notificationName:growlNotificationNames[type] iconData:nil priority: 0\
+								   isSticky: NO clickContext:nil];
+}
+
 @end
Index: contrib/Pallet/MPActionsController.h
===================================================================
--- contrib/Pallet/MPActionsController.h	(revision 65496)
+++ contrib/Pallet/MPActionsController.h	(revision 72223)
@@ -11,5 +11,9 @@
 #import "PortsTableController.h"
 #import "ActivityController.h"
+#import "MPCheckbox.h"
 
+#import "GrowlNotifications.h"
+
+extern BOOL altWasPressed;
 
 @interface MPActionsController : NSObject {
@@ -19,8 +23,36 @@
     
     IBOutlet NSToolbarItem *cancel;
+	IBOutlet NSButton *startQueueButton;
+	IBOutlet NSButton *removeFromQueueButton;
+	IBOutlet NSMutableArray *queueArray;
+    IBOutlet NSArrayController *queue;
+	NSUInteger queueCounter;
+	
+	//Variants Panel
+    IBOutlet NSPanel *variantsPanel;
+	
+	//Info Panel
+	IBOutlet NSPanel *infoPanel;
+	
+	//To make our checkbox management easier, we hold our checkboxes in array 
+	MPCheckbox* checkboxes[10];
+	
+	//We set 10 checkboxes, that will hold our port variants
+	IBOutlet MPCheckbox *chckbx0;
+	IBOutlet MPCheckbox *chckbx1;
+	IBOutlet MPCheckbox *chckbx2;
+	IBOutlet MPCheckbox *chckbx3;
+	IBOutlet MPCheckbox *chckbx4;
+	IBOutlet MPCheckbox *chckbx5;
+	IBOutlet MPCheckbox *chckbx6;
+	IBOutlet MPCheckbox *chckbx7;
+	IBOutlet MPCheckbox *chckbx8;
+	IBOutlet MPCheckbox *chckbx9;	
 }
 
 - (IBAction)openPreferences:(id)sender;
 - (IBAction)install:(id)sender;
+- (IBAction)installWithVariantsChoose:(id)sender;
+- (IBAction)installWithVariantsPerform:(id)sender;
 - (IBAction)uninstall:(id)sender;
 - (IBAction)upgrade:(id)sender;
@@ -28,4 +60,15 @@
 - (IBAction)selfupdate:(id)sender;
 - (IBAction)cancel:(id)sender;
+- (IBAction)toggleInfoPanel: (id) sender;
+
+-(IBAction)clickCheckbox:(id)sender;
+-(void)setConflicts: (MPPort*) port;
+
+- (void)queueOperation: (NSString*) operation portName: (NSString*) name portObject: (id) port variants: (NSMutableArray*) variants;
+
+-(IBAction) startQueue:(id) sender;
+//-(IBAction) removeFromQueue:(id) sender;
+-(void)clearQueue;
+-(void)advanceQueue;
 
 @end
